import pytest
from importers.current_ads import converter

drivers_licenses_test_data = [
    {'input': {'korkort': [{'namn': 'B', 'varde': 'VTK8_WRx_GcM'}]},
     'expected': [{'concept_id': 'VTK8_WRx_GcM', 'legacy_ams_taxonomy_id': '3', 'label': 'B'}]},
    {'input': {'korkort': [{'namn': 'B', 'varde': 'VTK8_WRx_GcM'}, {'namn': 'C1', 'varde': 'swP6_psb_FCB'}]},
     'expected': [{'concept_id': 'VTK8_WRx_GcM', 'legacy_ams_taxonomy_id': '3', 'label': 'B'},
                  {'concept_id': 'swP6_psb_FCB', 'legacy_ams_taxonomy_id': '12', 'label': 'C1'}]},
    {'input': {'korkort': [{'namn': 'B', 'varde': 'VTK8_WRx_GcM'}, {'namn': 'D', 'varde': 'hK1a_wsQ_4UG'}]},
     'expected': [{'concept_id': 'VTK8_WRx_GcM', 'legacy_ams_taxonomy_id': '3', 'label': 'B'},
                  {'concept_id': 'hK1a_wsQ_4UG', 'legacy_ams_taxonomy_id': '5', 'label': 'D'}]},
    {'input': {'korkort': [{'namn': 'AM', 'varde': '4HpY_e2U_TUH'}]},
     'expected': [{'concept_id': '4HpY_e2U_TUH', 'legacy_ams_taxonomy_id': '16', 'label': 'AM'}]},
    {'input': {'korkort': [{'namn': 'B', 'varde': 'VTK8_WRx_GcM'}, {'namn': 'Utökad B', 'varde': 'ftCQ_gFu_L4b'},
                           {'namn': 'BE', 'varde': 'bcFd_Vkt_KXL'}, {'namn': 'C1', 'varde': 'swP6_psb_FCB'},
                           {'namn': 'C', 'varde': 'BKCx_hST_Pcm'}]},
     'expected': [{'concept_id': 'VTK8_WRx_GcM', 'legacy_ams_taxonomy_id': '3', 'label': 'B'},
                  {'concept_id': 'ftCQ_gFu_L4b', 'legacy_ams_taxonomy_id': '18', 'label': 'Utökad B'},
                  {'concept_id': 'bcFd_Vkt_KXL', 'legacy_ams_taxonomy_id': '6', 'label': 'BE'},
                  {'concept_id': 'swP6_psb_FCB', 'legacy_ams_taxonomy_id': '12', 'label': 'C1'},
                  {'concept_id': 'BKCx_hST_Pcm', 'legacy_ams_taxonomy_id': '4', 'label': 'C'}]},
    {'input': {'korkort': [{'namn': 'BE', 'varde': 'bcFd_Vkt_KXL'}, {'namn': 'CE', 'varde': 'zZu8_iZ9_wMH'}]},
     'expected': [{'concept_id': 'bcFd_Vkt_KXL', 'legacy_ams_taxonomy_id': '6', 'label': 'BE'},
                  {'concept_id': 'zZu8_iZ9_wMH', 'legacy_ams_taxonomy_id': '7', 'label': 'CE'}]},
    {'input': {'korkort': [{'namn': 'B', 'varde': 'VTK8_WRx_GcM'}, {'namn': 'C', 'varde': 'BKCx_hST_Pcm'},
                           {'namn': 'CE', 'varde': 'zZu8_iZ9_wMH'}]},
     'expected': [{'concept_id': 'VTK8_WRx_GcM', 'legacy_ams_taxonomy_id': '3', 'label': 'B'},
                  {'concept_id': 'BKCx_hST_Pcm', 'legacy_ams_taxonomy_id': '4', 'label': 'C'},
                  {'concept_id': 'zZu8_iZ9_wMH', 'legacy_ams_taxonomy_id': '7', 'label': 'CE'}]},
    {'input': {'korkort': [{'namn': 'B', 'varde': 'VTK8_WRx_GcM'}, {'namn': 'C', 'varde': 'BKCx_hST_Pcm'}]},
     'expected': [{'concept_id': 'VTK8_WRx_GcM', 'legacy_ams_taxonomy_id': '3', 'label': 'B'},
                  {'concept_id': 'BKCx_hST_Pcm', 'legacy_ams_taxonomy_id': '4', 'label': 'C'}]},
    {'input': {'korkort': [{'namn': 'B', 'varde': 'VTK8_WRx_GcM'}, {'namn': 'AM', 'varde': '4HpY_e2U_TUH'}]},
     'expected': [{'concept_id': 'VTK8_WRx_GcM', 'legacy_ams_taxonomy_id': '3', 'label': 'B'},
                  {'concept_id': '4HpY_e2U_TUH', 'legacy_ams_taxonomy_id': '16', 'label': 'AM'}]},
    {'input': {'korkort': [{'namn': 'CE', 'varde': 'zZu8_iZ9_wMH'}]},
     'expected': [{'concept_id': 'zZu8_iZ9_wMH', 'legacy_ams_taxonomy_id': '7', 'label': 'CE'}]},
    {'input': {'korkort': [{'namn': 'BE', 'varde': 'bcFd_Vkt_KXL'}, {'namn': 'B', 'varde': 'VTK8_WRx_GcM'}]},
     'expected': [{'concept_id': 'bcFd_Vkt_KXL', 'legacy_ams_taxonomy_id': '6', 'label': 'BE'},
                  {'concept_id': 'VTK8_WRx_GcM', 'legacy_ams_taxonomy_id': '3', 'label': 'B'}]},
    {'input': {'korkort': [{'namn': 'C', 'varde': 'BKCx_hST_Pcm'}]},
     'expected': [{'concept_id': 'BKCx_hST_Pcm', 'legacy_ams_taxonomy_id': '4', 'label': 'C'}]},
    {'input': {'korkort': [{'namn': 'C1', 'varde': 'swP6_psb_FCB'}]},
     'expected': [{'concept_id': 'swP6_psb_FCB', 'legacy_ams_taxonomy_id': '12', 'label': 'C1'}]},
    {'input': {'korkort': [{'namn': 'C', 'varde': 'BKCx_hST_Pcm'}, {'namn': 'B', 'varde': 'VTK8_WRx_GcM'}]},
     'expected': [{'concept_id': 'BKCx_hST_Pcm', 'legacy_ams_taxonomy_id': '4', 'label': 'C'},
                  {'concept_id': 'VTK8_WRx_GcM', 'legacy_ams_taxonomy_id': '3', 'label': 'B'}]},
    {'input': {'korkort': [{'namn': 'B', 'varde': 'VTK8_WRx_GcM'}, {'namn': 'CE', 'varde': 'zZu8_iZ9_wMH'},
                           {'namn': 'C', 'varde': 'BKCx_hST_Pcm'}]},
     'expected': [{'concept_id': 'VTK8_WRx_GcM', 'legacy_ams_taxonomy_id': '3', 'label': 'B'},
                  {'concept_id': 'zZu8_iZ9_wMH', 'legacy_ams_taxonomy_id': '7', 'label': 'CE'},
                  {'concept_id': 'BKCx_hST_Pcm', 'legacy_ams_taxonomy_id': '4', 'label': 'C'}]},
    {'input': {'korkort': [{'namn': 'Utökad B', 'varde': 'ftCQ_gFu_L4b'}]},
     'expected': [{'concept_id': 'ftCQ_gFu_L4b', 'legacy_ams_taxonomy_id': '18', 'label': 'Utökad B'}]},
    {'input': {'korkort': [{'namn': 'B', 'varde': 'VTK8_WRx_GcM'}, {'namn': 'BE', 'varde': 'bcFd_Vkt_KXL'}]},
     'expected': [{'concept_id': 'VTK8_WRx_GcM', 'legacy_ams_taxonomy_id': '3', 'label': 'B'},
                  {'concept_id': 'bcFd_Vkt_KXL', 'legacy_ams_taxonomy_id': '6', 'label': 'BE'}]},
    {'input': {'korkort': [{'namn': 'C', 'varde': 'BKCx_hST_Pcm'}, {'namn': 'CE', 'varde': 'zZu8_iZ9_wMH'}]},
     'expected': [{'concept_id': 'BKCx_hST_Pcm', 'legacy_ams_taxonomy_id': '4', 'label': 'C'},
                  {'concept_id': 'zZu8_iZ9_wMH', 'legacy_ams_taxonomy_id': '7', 'label': 'CE'}]},
    {'input': {'korkort': [{'namn': 'A', 'varde': 'hK8X_cX9_5P4'}]},
     'expected': [{'concept_id': 'hK8X_cX9_5P4', 'legacy_ams_taxonomy_id': '10', 'label': 'A'}]},
    {'input': {'korkort': [{'namn': 'BE', 'varde': 'bcFd_Vkt_KXL'}]},
     'expected': [{'concept_id': 'bcFd_Vkt_KXL', 'legacy_ams_taxonomy_id': '6', 'label': 'BE'}]},
    {'input': {'korkort': [{'namn': 'B', 'varde': 'VTK8_WRx_GcM'}, {'namn': 'Utökad B', 'varde': 'ftCQ_gFu_L4b'},
                           {'namn': 'C1', 'varde': 'swP6_psb_FCB'}, {'namn': 'C', 'varde': 'BKCx_hST_Pcm'}]},
     'expected': [{'concept_id': 'VTK8_WRx_GcM', 'legacy_ams_taxonomy_id': '3', 'label': 'B'},
                  {'concept_id': 'ftCQ_gFu_L4b', 'legacy_ams_taxonomy_id': '18', 'label': 'Utökad B'},
                  {'concept_id': 'swP6_psb_FCB', 'legacy_ams_taxonomy_id': '12', 'label': 'C1'},
                  {'concept_id': 'BKCx_hST_Pcm', 'legacy_ams_taxonomy_id': '4', 'label': 'C'}]},
]


@pytest.mark.parametrize("test_case", drivers_licenses_test_data)
def test_drivers_license(test_case):
    converted = converter.parse_driving_licence(test_case['input'])
    assert converted == test_case['expected']
